Attribute VB_Name = "m_Steganography"
Option Explicit

Public Function EncryptPicture(ByRef oPicture As PictureBox, ByVal FileName As String)
    Dim lColor As Long 'couleur du point de l'image
    Dim lX As Long 'position sur l'image en X
    Dim lY As Long 'position sur l'image en Y
    Dim lMLength As Long 'taille du message
    Dim sChar As String * 1 'caractere lu dans le fichier
    Dim lChar As Long 'caractere en cours de traitement
    Dim lByte As Long 'nombre d'octet lu dans le message
    'Dim lLevel As Long 'vaut 0 si on en est au premier quartet de l'octet ou 1 si c'est le second
    Dim lByteToWrite As Long 'contient les donnees a mettre dans l'image
    
    
    Dim lRed As Long
    Dim lBlue As Long
    Dim lGreen As Long
    
    Dim iFile As Integer 'numero du fichier ouvert
        
    lByte = 1
    lMLength = FileLen(FileName)
    
    Call Randomize(Timer)
    
    'on ecrit la taille du message dans le premier pixel en haut a gauche
            lColor = lMLength
            'on enregistre la nouvelle couleur
            oPicture.PSet (0, 0), lColor
            
            'on initialise les valeurs minimales et maximales de la barre de progression
            frmMain.pgbState.Min = 1
            frmMain.pgbState.Max = lMLength
            
    
    iFile = FreeFile
    Open FileName For Binary Access Read Lock Read Write As #iFile
    
    'on va parcourir chaque point de l'image
    'les bords gauche/droit et haut/bas sont supprims : ils posaient des porblmes !
    'la premire ligne ( cause du point 0,0) sert a enregistrer la taille du message
    'en octet : limite de 2^32 octets, evidemment!
    For lY = 1 To oPicture.ScaleHeight - 1 Step 1
        For lX = 1 To oPicture.ScaleWidth - 1 Step 1
            
            'on extrait la couleur de l'image
            lColor = oPicture.Point(lX, lY)
                        
            'on verifie maintenant la valeur de level
            'si level=0, c'est qu'on doit extraire les 4 premiers bit de l'octet
            'dans lequel on se trouve du message
            'si level=1, on lit les 4 derniers bit de l'octet
            'If (lLevel = 0) Then
            '    'on extrait l'octet du message puis on le passe par un masque qui va
            '    'ne garde que les quatre premiers bit
            '    lByteToWrite = Asc(Mid$(sMessage, lHalfByte, 1)) And &HF&
            '
            '    lLevel = 1 'on met level a 1 pour le prochain passage
            'Else
            '    'on extrait l'octet du message et le masque permet de ne guarder que
            '    'les quatre derniers bit (les quatre premier sont a 0)
            '    lByteToWrite = Asc(Mid$(sMessage, lHalfByte, 1)) And &HF0&
            '
            '    'afin de decaler les bit a droite, et ainsi supprimer
            '    'les zero, on divise par 16 le nombre precedent
            '    lByteToWrite = lByteToWrite / &H10&
            '
            '    lLevel = 0 'on met level a 0 pour le prochain passage
            '    lHalfByte = lHalfByte + 1 'on incremente pour dire que la prochaine fois on lira l'octet suivant
            'End If
            
            'on passe lColor au masque
            'ca permet de supprimer les 4 bit de plus bas niveau
            'lcolor = lcolor And &HFFFFFFF0
            'on additionne la couleur de l'image avec les quatre octets
            'precedemment extraits
            'lcolor = lcolor Or lByteToWrite
            
            
            'on extrait l'octet du fichier
            Get #iFile, lByte, sChar
            lChar = Asc(sChar)
                        
            Call DecomposeRGB(ByVal lColor, lRed, lGreen, lBlue)
            
            'on modifie la couleur rouge
            'on garde la partie la plus forte et on enleve l'autre partie
            lRed = (lRed And &HF0&) Or (lChar And &HF&)
            
            'on modifie de la meme facon la couleur bleu
            lBlue = (lBlue And &HF0&) Or ((lChar And &HF0&) / &H10&)
            
            lByte = lByte + 1
            
            'on reconstruit la couleur
            lColor = RGB(lRed, lGreen, lBlue)
            
            'on enregistre la nouvelle couleur
            oPicture.PSet (lX, lY), lColor
            
            'on verifie si on a pas termine
            If (lByte > lMLength) Then
                oPicture.Picture = oPicture.Image
                Close #iFile
                Exit Function
            End If
            
        Next lX
        'on modifie la valeur de la barre de progression
        'pour informer l'utilisateur de l'avancement
        frmMain.pgbState.Value = lByte: DoEvents
    Next lY
    
    Close #iFile
    
    
End Function

Public Function DecryptPicture(ByRef oPicture As PictureBox, ByVal FileName As String)
    Dim lColor As Long 'couleur du point de l'image
    Dim lX As Long 'position sur l'image en X
    Dim lY As Long 'position sur l'image en Y
    Dim lLength As Long 'longueur du message
    Dim iFile As Integer
    
    'Dim lLevel As Long 'vaut 0 si on en est au premier quartet de l'octet ou 1 si c'est le second
    Dim lByte As Long 'nombre d'octet lu dans le message
    Dim lChar As String
        
    Dim lRed As Long
    Dim lBlue As Long
    Dim lGreen As Long
    
    
    lByte = 1
    
    'on extrait la longueur du message
    lLength = oPicture.Point(0, 0)
    
            'on initialise la barre de progression
            frmMain.pgbState.Min = 1
            frmMain.pgbState.Max = lLength
    
    iFile = FreeFile
    'on ecrit le resultat
    Open FileName For Binary Access Write Lock Read Write As #iFile
        
        'on va parcourir chaque point de l'image
        For lY = 1 To oPicture.ScaleHeight - 1 Step 1
            For lX = 1 To oPicture.ScaleWidth - 1 Step 1
                
                'on extrait la couleur de l'image
                lColor = oPicture.Point(lX, lY)
                            
                'on passe lColor au masque afin de ne guarder que la partie
                'qui nous interresse, c'est a dire les quatre premiers bit
                'lcolor = lcolor And &HF
                    
                'si lLevel = 0 c'est qu'on extrait les quatres bit de plus faible poids
                'sinon, c'est les quatre bit de poids fort
                'If (lLevel = 0) Then
                '    'on enregistre les bit de poids faible (rien de particulier a faire)
                '    lChar = lcolor
                '    lLevel = 1 'on met lLevel a 1 parce que la prochaine fois on traitera les quatre bit de plus fort poids
                '
                'ElseIf (lLevel = 1) Then
                '
                '    'afin de remettre les choses a leur place, on decale vers
                '    'la gauche les bit en multipliant par 16
                '    lcolor = lcolor * &H10&
                '    'on fait la somme avec les quatre bit de poids faible
                '    'et on obtient alors l'octet original !
                '    lChar = lChar Or lcolor
                '
                '    'on ecrit l'octet dans le fichier de sortie
                '    Put #iFile, , Chr$(lChar)
                '
                '    lLevel = 0 'on remet lLevel a 0...
                '    lHalfByte = lHalfByte + 1 '... et on incremente pour savoir ou on en est
                'End If
                
                'on decompose le pixel
                Call DecomposeRGB(ByVal lColor, lRed, lGreen, lBlue)
                'on a plus qu'a extraire l'octet...
                'selon le mode d'enregistrement (voir l'algo de cryptage)
                'lRed contient le poids faible et lBlue le poids fort
                lChar = ((lBlue And &HF&) * &H10&) Or (lRed And &HF&)
                
                'on ecrit l'octet dans le fichier de sortie
                Put #iFile, , Chr$(lChar)
                
                
                lByte = lByte + 1
                
                'on verifie si la fin a ete atteinte
                If (LOF(iFile) >= lLength) Then
                    Close #iFile
                    Exit Function
                End If
                
            Next lX
            
            'on informe l'utilisateur de l'avancement de l'operation
            frmMain.pgbState.Value = lByte: DoEvents
            
        Next lY
        
    Close #iFile
    
End Function

Public Function ByteBeAbleToWrite(ByRef oPicture As PictureBox) As Long
    'on renvoie le nombre d'octets de donnees que peut contenir une image
    'cela represente (a peu pres, car on supprime les bords) la moitie de sa
    'hauteur par sa largeur
    ByteBeAbleToWrite = (oPicture.ScaleWidth - 2) * (oPicture.ScaleHeight - 2)
End Function

'cette fonction decompose une couleur en ses composantes rouge, vert et bleu
Public Function DecomposeRGB(ByVal lColor As Long, ByRef lRed As Long, ByRef lGreen As Long, ByRef lBlue As Long)
    lRed = lColor And &HFF&
    lGreen = (lColor And &HFF00&) / &H100&
    lBlue = (lColor And &HFF0000) / &H10000
End Function
